<script>
import { mapActions } from "vuex";
import { QrcodeStream } from "vue-qrcode-reader";

export default {
  components: { QrcodeStream },

  data() {
    return {
      result: "",
      error: "",
      success: false,
    };
  },

  methods: {
    ...mapActions({
      approveQRCode: "events/approveQRCode",
    }),

    onDecode(result) {
      this.approveQRCode({ eventId: this.$route.params.id, code: result }).then(
        () => {
          this.success = true;

          setTimeout(() => {
            this.$router.go(-1);
          }, 2000);
        }
      );
    },

    async onInit(promise) {
      try {
        await promise;
      } catch (error) {
        if (error.name === "NotAllowedError") {
          this.error = "ERROR: you need to grant camera access permission";
        } else if (error.name === "NotFoundError") {
          this.error = "ERROR: no camera on this device";
        } else if (error.name === "NotSupportedError") {
          this.error = "ERROR: secure context required (HTTPS, localhost)";
        } else if (error.name === "NotReadableError") {
          this.error = "ERROR: is the camera already in use?";
        } else if (error.name === "OverconstrainedError") {
          this.error = "ERROR: installed cameras are not suitable";
        } else if (error.name === "StreamApiNotSupportedError") {
          this.error = "ERROR: Stream API is not supported in this browser";
        } else if (error.name === "InsecureContextError") {
          this.error =
            "ERROR: Camera access is only permitted in secure context. Use HTTPS or localhost rather than HTTP.";
        } else {
          this.error = `ERROR: Camera error (${error.name})`;
        }
      }
    },
  },
};
</script>

<template>
  <div class="qr">
    <v-alert v-if="success" class="qr__notify" type="success">
      QR код успешно считан
    </v-alert>

    <div class="qr__block">
      <div class="qr__wrapper">
        <h1>Отскангируйте QR код</h1>

        <div class="qr__view">
          <qrcode-stream @decode="onDecode" @init="onInit" />
        </div>

        <v-btn width="100%" color="info" @click="$router.go(-1)">
          Отмена
        </v-btn>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.qr {
  background-image: url("../assets/images/qr_background.png") !important;
  background-size: cover;
  height: 100%;
  position: relative;

  &__notify {
    position: absolute;
    bottom: 32px;
    left: 0;
    right: 0;
    max-width: 500px;
    margin: 0 auto;
    z-index: 9999;
  }

  &__block {
    background: rgba(33, 33, 33, 0.46);
    width: 100%;
    height: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
  }

  &__wrapper {
    max-width: 338px;
    display: flex;
    flex-direction: column;
    align-items: center;

    h1 {
      color: #fff;
      margin-bottom: 64px;
    }
  }

  &__view {
    width: 300px;
    height: 300px;
    border: 3px solid #ffffff;
    margin-bottom: 40px;
  }
}
</style>
